---
# Input assertions
- name: Assert wireguard input variables
  run_once: true
  delegate_to: localhost
  no_log: true
  assert:
    that: item | length > 0
    fail_msg: "{{ item }} option is not set in vars, make sure it is present"
    quiet: true
  with_items:
    - "{{ wireguard_local_private_key }}"
    - "{{ wireguard_local_public_key }}"
    - "{{ wireguard_local_ip_address }}"
    - "{{ wireguard_peer_public_key }}"
    - "{{ wireguard_peer_ip_address }}"
    - "{{ wireguard_peer_port | string }}"
    - "{{ wireguard_peer_allowed_ips }}"

# Install and configure wireguard
- name: Install Wireguard package
  become: true
  apt:
    name: wireguard
    state: present
  register: wireguard_package

- name: Add hosts config to preven sudo problems
  become: true
  template:
    src: hosts.j2
    dest: /etc/hosts
    owner: root
    group: root
    mode: u=rw,g=r,o=r
  when: wireguard_package.changed

- name: set allowed IPs
  set_fact:
    _wireguard_peer_allowed_ips: "{{ wireguard_peer_allowed_ips | join(',')}}"

- name: Create Systemd network config
  become: true
  template:
    src: "{{ item }}.j2"
    dest: "/etc/systemd/network/{{ item }}"
    owner: root
    group: root
  with_items:
    - 99-wg0.netdev
    - 99-wg0.network
  notify: wireguard_reload_network_config

- name: Running all handlers
  meta: flush_handlers
...